/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        
        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Set gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cicle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set save last value
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
        
        if($Elem.find(".icon").length < 1){
            var $div = $("<div></div>");
            $div.css("height","64px").css("width","100%").text(_D("Any icon"));
            $Elem.append($div);
        }

        //Set Combo Values
        $Elem = $componentProperties.find("[eve-manager-id='values']");
        aValue = oComponent.getParamVal("values");
        $Elem.find("input[type='text']").remove();
        for(var i=0; i<aValue.length; ++i){
            
            if(aValue[i].value == "" && aValue[i].description == ""){
                continue;
            }
            
            var $line = getComboHtmlLine();
            $line.find(".value").val(aValue[i].value);
            $line.find(".description").val(aValue[i].description);
            
            //Append
            $Elem.find("form").append($line);
        }
        
        if($Elem.find("input[type='text']").length < 1){
            $Elem.find("form").append(getComboHtmlLine());
        }

        //Set read only
        $Elem = $componentProperties.find("[eve-manager-id='read-only']");
        $Elem.prop("checked",oComponent.getParamVal("read-only"));

        /** KNX */
        
        //Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX - functional block
        $Elem = $componentProperties.find("[eve-manager-id='knx/functional-block'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            
            if($currElem.val() == oComponent.getParamVal("knx/functional-block")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }

        //Set KNX range
        $Elem = $componentProperties.find("[eve-manager-id='knx/range'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);

            if($currElem.val() == oComponent.getParamVal("knx/range")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));


        /*aValue = oComponent.getParamVal("knx/range");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }*/
        
        /** VIMAR By Me */
        
        //Set Vimar By Me
        $.ajax({
            url: "./declarations/vimar/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                
                //Parsing Vimar By Me Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("combo") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("VimarByMe",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                
                //Select currently Vimar By Me device
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vimar/device-pid") +"']");
                var oVimarDevice = $selected.data("VimarByMe");
                $selected.prop("selected",true);
                
                //Filter Device Function Block
                var $fid = $componentProperties.find("[eve-manager-id='vimar/device-fid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                
                //Empty combo selection
                $fid.empty();
                $fid.append($none);
                
                //Check if none device is selected
                if(oVimarDevice == undefined){
                    $none.prop("selected",true);
                    $fid.prop("disabled",true);
                }
                else{
                    //Filter Device Function Block
                    switch(oVimarDevice.pid){
                        case "6C":
                            for(var i=0; i<oVimarDevice.fid.length; ++i){
                                //if(oVimarDevice.fid[i].value != 3 && oVimarDevice.fid[i].value != 4){
                                if(oVimarDevice.fid[i].value != 3 && oVimarDevice.fid[i].value != 1){
                                    continue;
                                }
                                
                                var $option = $("<option></option>");
                                
                                $option.text(_D(oVimarDevice.fid[i].label));
                                $option.val(oVimarDevice.fid[i].value);
                                
                                $fid.append($option);
                            }
                            break;
                        case "90":
                            for(var i=0; i<oVimarDevice.fid.length; ++i){
                                //if(oVimarDevice.fid[i].value != 4 && oVimarDevice.fid[i].value != 7 && oVimarDevice.fid[i].value != 2){
                                if(oVimarDevice.fid[i].value != 1 && oVimarDevice.fid[i].value != 7 && oVimarDevice.fid[i].value != 2){
                                    continue;
                                }
                                
                                var $option = $("<option></option>");
                                
                                $option.text(_D(oVimarDevice.fid[i].label));
                                $option.val(oVimarDevice.fid[i].value);
                                
                                $fid.append($option);
                            }
                            break;
                    }
                    
                    $fid.removeProp("disabled");
                }
                
                //Select fid
                $fid.find("[value='"+ oComponent.getParamVal("vimar/device-fid") +"']").prop("selected",true);
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        //Set Vimar physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/physical-address"));
        
        //Set Vimar group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/group-address"));

        //Set simulation feedback
        var $Elem = $componentProperties.find("[eve-manager-id='vimar/enable-sfbk']");
        $Elem.prop("checked", oComponent.getParamVal("vimar/enable-sfbk") );
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"vimar/enable-sfbk"]);

        //Set simulation feedback address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/sfbk']");
        var aValue = oComponent.getParamVal("vimar/sfbk").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        /** Datagram */
        $Elem = $componentProperties.find("[eve-manager-id='datagram/broadcast']");
        $Elem.prop("checked",oComponent.getParamVal("datagram/broadcast"));

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
		
		/** Z-Wave */
		$Elem = $componentProperties.find("[eve-manager-id='zwave/label']");
        $Elem.val(oComponent.getParamVal("zwave/label"));
		
        $Elem = $componentProperties.find("[eve-manager-id='zwave/node']");
        $Elem.val(oComponent.getParamVal("zwave/node"));

        $Elem = $componentProperties.find("[eve-manager-id='zwave/instance']");
        $Elem.val(oComponent.getParamVal("zwave/instance"));
        
        /** Vivaldi */
		
		//Set Vivaldi products
        $.ajax({
            url: "./declarations/vivaldi/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
				
                //Parsing Vivaldi Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("combo") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("Vivaldi",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
				
				//Disable if exist one choice
				//$dropDown.prop("disabled",true);
                
                //Select currently PID
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-pid") +"']");
                
				//Select vivaldi device
                $selected.prop("selected",true);
                
                var oVivaldiDevice = $selected.data("Vivaldi");
                
                if(oVivaldiDevice == undefined){
                	return;
                }
			
				//Fill RC20 address
				$dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-id']");
                for(var i=0; i<oVivaldiDevice.idList.length; ++i){
                    var $option = $("<option></option>");
					$option.text(oVivaldiDevice.idList[i]);
					$option.val(oVivaldiDevice.idList[i]);
                    
					$dropDown.append($option);
                }
				
				var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-id") +"']");
				$selected.prop("selected",true);
				
				//Fill Function ID
				$dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']");
                for(var i=0; i<oVivaldiDevice.fidList.length; ++i){
					if(oVivaldiDevice.fidList[i].fid == 4) {
					    var $option = $("<option></option>");
						$option.text(oVivaldiDevice.fidList[i].label);
						$option.val(oVivaldiDevice.fidList[i].fid);
                    
						$dropDown.append($option);
					}
                }
				
				var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-fid") +"']");
				$selected.prop("selected",true);
				$dropDown.prop("disabled", true);
				
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        /** Aernova */
        
        //Set Aernova modes
        $.ajax({
            url: "./declarations/aernova/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='aernova/mode']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                //Parsing Aernova modes
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                   	if(json[i].fid == 11 || json[i].fid == 14 || json[i].fid == 15 || json[i].fid == 41 || json[i].fid == 46 || json[i].fid == 84 || json[i].fid == 104) {
                        $option.text(_D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.attr("dictionary", json[i].label);
                        $option.val(json[i].fid);
                        $option.data("Aernova",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }        
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("aernova/mode") +"']");
				$selected.prop("selected",true);			
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
		
        $Elem = $componentProperties.find("[eve-manager-id='aernova/address']");
        $Elem.val(oComponent.getParamVal("aernova/address"));

        // Modbus
        $.ajax({
            url: "./declarations/modbus/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for(var i=0; i<json.unit_id.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-unit-id") +"']").prop("selected",true);

                //switch_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for(var i=0; i<json.switch_transform_type.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.switch_transform_type[i].label));
                    $option.attr("title", _D(json.switch_transform_type[i].label));
                    $option.attr("dictionary", json.switch_transform_type[i].label);
                    $option.val(json.switch_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-transform-type") +"']").prop("selected",true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for(var i=0; i<json.read_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-function-id") +"']").prop("selected",true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for(var i=0; i<json.write_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-function-id") +"']").prop("selected",true);

            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });

        // ModbusTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));



        // ModbusTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-multiplier"));


        // ModbusRTUTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

        // ModbusRTUTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));
    };
}
catch(err){
    console.error(err);
}
