/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){

        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));

        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));

        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");

        //Set gateways
        var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;

            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){

                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle

                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }

        //Disable Gateway
        $("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);
        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        for(var i=0; i<aIcons.length; ++i){
            var oIcon = aIcons[i];
            var $wrapper = $("<div class='icon'></div>");
            var $canvas = $("<canvas></canvas>");
            var $status = $("<span></span>");
            var img = document.getElementById(oIcon.srcId);
            //var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");
            
            //Default image loading
            var imgHeight = parseInt(img.height,10);                        // Image height
            var imgWidth = parseInt(img.width,10);                          // Image width


            console.log(imgHeight);
            console.log(imgWidth);

            var stretchScale = 0.5;
            var drawHeight = imgHeight * stretchScale;
            var drawWidth = imgWidth * stretchScale; 
            var canvas = $canvas[0];
            var cont = canvas.getContext("2d");
            
            $canvas.attr("height",50);
            $canvas.attr("width",51);
            
            //Height - Width streched
            cont.drawImage(img,(oIcon.position.x * stretchScale),(oIcon.position.y * stretchScale),drawWidth,drawHeight);
            
            var imageData = cont.getImageData(0,0,50,51);
            
            //Color image
            if(oIcon.enableColors){
                //Color image
                for(var j=0; j<imageData.data.length; j+=4){
                    imageData.data[j+0] = oIcon.color.R;
                    imageData.data[j+1] = oIcon.color.G;
                    imageData.data[j+2] = oIcon.color.B;
                    imageData.data[j+3] = imageData.data[j+3];
                }
            }
            
            cont.putImageData(imageData,0,0);
            
            $status.text(oIcon.status);
            
            $wrapper.append($canvas);
            $wrapper.append($status);
            $Elem.append($wrapper);
        }

        //
        $Elem = $componentProperties.find("[eve-manager-id='gui/src']");
        //$Elem.text(oComponent.getParamVal("gui/src"));
        $Elem.attr("src",oComponent.getParamVal("gui/src"));
    };
}
catch(err){
    console.error(err);
}
