/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set html name
    	var $Elem = $("#"+ oComponent.id +" .components-text");
    	$Elem.text(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	var $Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='history']");
    	$Elem.prop("checked",oComponent.getParamVal("history"));
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
    	$Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='cache']");
    	$Elem.prop("checked",oComponent.getParamVal("cache"));

    	
    	//Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
    	
    	//Set local url
        var $Elem = $componentProperties.find("[eve-manager-id='local-url']");
        $Elem.val(oComponent.getParamVal("local-url"));
        
        //Set local video format
        var $Elem = $componentProperties.find("[eve-manager-id='local-video-format'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            
            if($currElem.val() == oComponent.getParamVal("local-video-format")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }
        
        //Set remote url
        var $Elem = $componentProperties.find("[eve-manager-id='remote-url']");
        $Elem.val(oComponent.getParamVal("remote-url"));
    	
    	//Set remote video format
        var $Elem = $componentProperties.find("[eve-manager-id='remote-video-format'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            
            if($currElem.val() == oComponent.getParamVal("remote-video-format")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }
        
        //Set local url list
        var $Elem = $componentProperties.find("[eve-manager-id='local-url-list']");
        $Elem.val(oComponent.getParamVal("local-url-list"));
    	
    	$("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );
    };
}
catch(err){
    console.error(err);
}
