/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set html name
    	var $Elem = $("#"+ oComponent.id +" .components-text");
    	$Elem.text(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	var $Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='history']");
    	$Elem.prop("checked",oComponent.getParamVal("history"));
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
    	$Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
    	
    	//Set enable history
    	var $Elem = $componentProperties.find("[eve-manager-id='cache']");
    	$Elem.prop("checked",oComponent.getParamVal("cache"));


    	
    	//Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
    	
    	//Set KNX (RED) write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/red/write-address']");
        var aValue = oComponent.getParamVal("knx/red/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (RED) feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/red/feedback-address']");
        aValue = oComponent.getParamVal("knx/red/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (GREEN) write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/green/write-address']");
        var aValue = oComponent.getParamVal("knx/green/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (GREEN) feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/green/feedback-address']");
        aValue = oComponent.getParamVal("knx/green/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (BLUE) write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/blue/write-address']");
        var aValue = oComponent.getParamVal("knx/blue/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (BLUE) feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/blue/feedback-address']");
        aValue = oComponent.getParamVal("knx/blue/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));



        /** VIMAR By Me */
        
        //Set Vimar By Me
        $.ajax({
            url: "./declarations/vimar/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                
                //Parsing Vimar By Me Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("rgb-light") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("VimarByMe",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                
                //Select currently FID
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vimar/device-pid") +"']");
                var oVimarDevice = $selected.data("VimarByMe");
                
                $selected.prop("selected",true);
                
                var $fid = $componentProperties.find("[eve-manager-id='vimar/device-fid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                
                //Empty combo selection
                $fid.empty();
                $fid.append($none);
                
                //Check if none device is selected
                if(oVimarDevice == undefined){
                    $none.prop("selected",true);
                    $fid.prop("disabled",true);
                }
                else{
                    //Fill option parameters
                    for(var i=0; i<oVimarDevice.fid.length; ++i){
                        oVimarDevice.fid[i];
                        var $option = $("<option></option>");
                        
                        $option.text(_D(oVimarDevice.fid[i].label));
                        $option.val(oVimarDevice.fid[i].value);
                        
                        $fid.append($option);
                    }
                    
                    $fid.removeProp("disabled");
                }
                
                //Select currently
                $fid.find("[value='"+ oComponent.getParamVal("vimar/device-fid") +"']").prop("selected",true);
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        //Set Vimar red physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/red/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/red/physical-address"));
        
        //Set Vimar red group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/red/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/red/group-address"));
        
        //Set Vimar green physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/green/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/green/physical-address"));
        
        //Set Vimar green group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/green/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/green/group-address"));
        
        //Set Vimar blue physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/blue/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/blue/physical-address"));
        
        //Set Vimar blue group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/blue/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/blue/group-address"));

        //Set simulation feedback
        var $Elem = $componentProperties.find("[eve-manager-id='vimar/enable-sfbk']");
        $Elem.prop("checked", oComponent.getParamVal("vimar/enable-sfbk") );

        //Set simulation feedback address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/sfbk']");
        var aValue = oComponent.getParamVal("vimar/sfbk").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));

        //HUE
        $Elem = $componentProperties.find("[eve-manager-id='hue/id']");
        $Elem.val(oComponent.getParamVal("hue/id"));

        updateCustomData(oComponent);
    };
}
catch(err){
    console.error(err);
}
