/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitComponent(oComponent){
        
        //Call common initialize component inside mainframe
        $.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);
        
        //Set default values using Publish/Subscribe pattern
        oComponent.addParamVal("name",_D("Seeker"));
        
        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);

        oComponent.addParamVal("updateonchange",false);
        oComponent.addParamVal("keepopen",false);




        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oIcon_status_1 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        var panw=model["instance"].skin.IconsPan.imgWidth;
        var panh=model["instance"].skin.IconsPan.imgHeight;
        var iconw=model["instance"].skin.IconsPan.iconsWidth;
        var iconh=model["instance"].skin.IconsPan.iconsHeight;

		var i0=model["instance"].skin.ComponentsInfo.Seeker.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i1=model["instance"].skin.ComponentsInfo.Seeker.defaultIcons[1];
        $.extend(true, oIcon_status_1, {
            status: 1,
            position:{ x: -i1.position.x*iconw, y: -i1.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }
        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);
        aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"},
        		{id:1, label:"Modal"},
        		{id:2, label:"No label"},
        		{id:3, label:"Hidden"}
        	]);
        
        // GUI
        //oComponent.addParamVal("widget/type", $.getSyncJSON("./components/widget/widgets.json")[0]["type"] );
        //var aWidgets = $.getSyncJSON("./declarations/widgets.json");

        oComponent.addParamVal("widget/type", "seeker" );
        oComponent.addParamVal("widget/components", new Array() );

        // Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);







    }
}
catch(err){
    console.error(err);
}
