/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitComponent(oComponent){
        
        //Call common initialize component inside mainframe
        $.loadSyncScript("./components/mainframe/init.js");

        onInitMainframeComponent(oComponent);
        
        //Set default values using Publish/Subscribe pattern
        oComponent.addParamVal("name",_D("smartinfo"));
        
        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();


        /** ABILITARE I COMMENTI PER AGIUNGERE ICONA
         *
         */

        //var oIcon_status_1 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        var panw=model["instance"].skin.IconsPan.imgWidth;
        var panh=model["instance"].skin.IconsPan.imgHeight;
        var iconw=model["instance"].skin.IconsPan.iconsWidth;
        var iconh=model["instance"].skin.IconsPan.iconsHeight;

		var i0=model["instance"].skin.ComponentsInfo.SmartInfo.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        
        //Important: maintain original position
        aIcons.push(oIcon_status_0);
        //aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		//,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		//,{id:3, label:"Hidden"} 
        	]);

        // Components
        // BEGIN MUST BE ALWAYS EXIST
        console.log("Init SmartInfo");
        oComponent.addParamVal("gui/components-list",[
            {label:"Connection state"                                       ,uid:"gui/connectionState"          ,type:"info"},
            {label:"Serial port"                                            ,uid:"gui/serialName"               ,type:"info"},
            {label:"Last connection time"                                   ,uid:"gui/lastConnection"           ,type:"info"},
            {label:"Instant consumption Alarm"                              ,uid:"gui/instantAlarm"             ,type:"switch"},
            {label:"Daily Consumption Alarm"                                ,uid:"gui/dailyConsumptionAlarm"    ,type:"switch"},
            {label:"POD (Point of Delivery)"                                ,uid:"gui/S001R022"                 ,type:"info"},
            {label:"Contractual power"                                      ,uid:"gui/S001R001"                 ,type:"info"},
            {label:"Available power"                                        ,uid:"gui/S001R002"                 ,type:"info"},


            {label:"Totale Produzione"                                      ,uid:"gui/S000R108"                 ,type:"info"},
            {label:"Total daily active energy current date"                 ,uid:"gui/S000R105"                 ,type:"info"},
            {label:"Total daily active energy previous date"                ,uid:"gui/S000R103"                 ,type:"info"},
            {label:"Total daily active energy previous date"                ,uid:"gui/S000R101"                 ,type:"info"},
            {label:"Produzione"                                             ,uid:"gui/S000R050"                 ,type:"info"},
            {label:"Totale immissioni in rete"                              ,uid:"gui/S000R036"                 ,type:"info"},
            {label:"Potenza istantanea"                                     ,uid:"gui/S000R011"                 ,type:"info"},
            {label:"Consumo totale F4"                                      ,uid:"gui/S000R010"                 ,type:"info"},
            {label:"Consumo totale F3"                                      ,uid:"gui/S000R009"                 ,type:"info"},
            {label:"Consumo totale F2"                                      ,uid:"gui/S000R008"                 ,type:"info"},
            {label:"Consumo totale F1"                                      ,uid:"gui/S000R007"                 ,type:"info"},
            {label:"Consumo totale"                                         ,uid:"gui/S000R006"                 ,type:"info"},






        ]);

        oComponent.addParamVal("gui/components", new Array() );
        // END MUST BE ALWAYS EXIST

        oComponent.addParamVal("gui/dailyConsumptionAlarmLevel","5000");
        oComponent.addParamVal("gui/instantConsumptionAlarmLevel","3000");

        oComponent.addParamVal("gui/euroF1","0,065750");
        oComponent.addParamVal("gui/euroF2","0,070580");
        oComponent.addParamVal("gui/euroF3","0,062820");
        oComponent.addParamVal("gui/euroF4","0,000000");
    }
}
catch(err){
    console.error(err);
}
