/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
    	//Check

        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set html name
    	$Elem = $("#"+ oComponent.id +" .components-text");
    	$Elem.text(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}

    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='history']");
    	$Elem.prop("checked",oComponent.getParamVal("history"));
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
    	$Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='cache']");
    	$Elem.prop("checked",oComponent.getParamVal("cache"));


    	
    	//Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
    	
    	//Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));



        /** VIMAR By Me */
        
        //Set Vimar By Me
        $.ajax({
            url: "./declarations/vimar/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                
                //Parsing Vimar By Me Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("timed-thermostat") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("VimarByMe",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                
                //Select currently Vimar By Me device
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vimar/device-pid") +"']");
                var oVimarDevice = $selected.data("VimarByMe");
                $selected.prop("selected",true);
                
                //Filter Device Function Block
                var $fid = $componentProperties.find("[eve-manager-id='vimar/device-fid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                
                //Empty combo selection
                $fid.empty();
                $fid.append($none);
                $fid.prop("disabled",true);
                
                //Check if none device is selected
                if(oVimarDevice == undefined){
                    $none.prop("selected",true);
                }
                else{
                    //Filter Device Function Block
                    switch(oVimarDevice.pid){
                        case "6C":
                        case "90":
                            for(var i=0; i<oVimarDevice.fid.length; ++i){
                                if(oVimarDevice.fid[i].value != 6){
                                    continue;
                                }
                                
                                var $option = $("<option></option>");
                                
                                $option.text(_D(oVimarDevice.fid[i].label));
                                $option.val(oVimarDevice.fid[i].value);
                                
                                $fid.append($option);
                            }
                            break;
                    }
                }
                
                //Select fid
                $fid.find("[value='"+ oComponent.getParamVal("vimar/device-fid") +"']").prop("selected",true);
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        //Set Vimar physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/physical-address"));
        
        //Set Vimar group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/group-address"));

        //Set simulation feedback
        var $Elem = $componentProperties.find("[eve-manager-id='vimar/enable-sfbk']");
        $Elem.prop("checked", oComponent.getParamVal("vimar/enable-sfbk") );

        //Set simulation feedback address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/sfbk']");
        var aValue = oComponent.getParamVal("vimar/sfbk").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        /** Ghost */



        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
		
		/** Z-Wave */
		$Elem = $componentProperties.find("[eve-manager-id='zwave/label']");
        $Elem.val(oComponent.getParamVal("zwave/label"));
		
        $Elem = $componentProperties.find("[eve-manager-id='zwave/node']");
        $Elem.val(oComponent.getParamVal("zwave/node"));

        $Elem = $componentProperties.find("[eve-manager-id='zwave/instance']");
        $Elem.val(oComponent.getParamVal("zwave/instance"));
        
        /** Aernova */


        
        //Set Aernova modes
        $.ajax({
            url: "./declarations/aernova/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='aernova/mode']");
                //Parsing Aernova modes
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                   	if(json[i].fid == 1 || json[i].fid == 2 || json[i].fid == 3 || json[i].fid == 4 || json[i].fid == 5 || json[i].fid == 17|| json[i].fid == 38 || json[i].fid == 39 || json[i].fid == 73 || json[i].fid == 86) {
                        $option.text(_D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.attr("dictionary", json[i].label);
                        $option.val(json[i].fid);
                        $option.data("Aernova",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("aernova/mode") +"']");
				$selected.prop("selected",true);			
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
		
        $Elem = $componentProperties.find("[eve-manager-id='aernova/address']");
        $Elem.val(oComponent.getParamVal("aernova/address"));




        /** BTicino */  
       	$.ajax({
            url: "./declarations/bticino/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){

                var targetWho;
                //Parsing BTicino WHOS
                for(var i=0; i<json.length; ++i){
                    if(json[i].who == 4) { // 4 stands for thermoregulation
                        targetWho=json[i];
                        break;
                    }
                }
                if(targetWho!=null) {
                    //populate who dropdown
                    $dropDown = $componentProperties.find("[eve-manager-id='bticino/who']");
                    var $option = $("<option></option>");
                    $option.text(_D(targetWho.label));
                    $option.attr("title", _D(targetWho.label));
                    $option.attr("dictionary", targetWho.label);
                    $option.val(targetWho.who);
                    $option.data("BTicino",targetWho);
                    $dropDown.append($option);

                    var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/who") +"']").prop("selected",true);

                    //populate interface dropdown
                    $dropDown = $componentProperties.find("[eve-manager-id='bticino/interface']");
                    for(var i=0; i<targetWho.interfaces.length; ++i){

                        var $option = $("<option></option>");
                        $option.text(_D(targetWho.interfaces[i].label));
                        $option.attr("title", _D(targetWho.interfaces[i].label));
                        $option.attr("dictionary", targetWho.interfaces[i].label);
                        $option.val(targetWho.interfaces[i].bus);

                        //Append
                        $dropDown.append($option);

                    }

                    $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/interface") +"']").prop("selected",true);

                    //populate type dropdown
                    $dropDown = $componentProperties.find("[eve-manager-id='bticino/type']");
                    // Save Data for udpate html use
                    $dropDown.data("who_thermostat",targetWho);
                    for(var i=0; i<targetWho.types.length; ++i){

                        var $option = $("<option></option>");
                        $option.text(_D(targetWho.types[i].label));
                        $option.attr("title", _D(targetWho.types[i].label));
                        $option.attr("dictionary", targetWho.types[i].label);
                        $option.val(targetWho.types[i].pid);

                        //Append
                        $dropDown.append($option);

                    }
                    $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/type") +"']").prop("selected",true);
                    var iThermostatType = parseInt($selected.val(),10);

                    //populate address dropdown
                    switch(iThermostatType){
                        case 0:{
                            //alert("4 Zones");
                            $dropDown = $componentProperties.find("[eve-manager-id='bticino/address']");
                            for(var i=0; i<targetWho.addresses0.length; ++i){
                                var $option = $("<option></option>");
                                $option.text(_D(targetWho.addresses0[i].label));
                                $option.attr("title", _D(targetWho.addresses0[i].label));
                                $option.attr("dictionary", targetWho.addresses0[i].label);
                                $option.val(targetWho.addresses0[i].where);
                                //Append
                                $dropDown.append($option);
                            }
                        }break;
                        case 1:{
                            //alert("99 Zones");
                            $dropDown = $componentProperties.find("[eve-manager-id='bticino/address']");
                            for(var i=0; i<targetWho.addresses1.length; ++i){
                                var $option = $("<option></option>");
                                $option.text(_D(targetWho.addresses1[i].label));
                                $option.attr("title", _D(targetWho.addresses1[i].label));
                                $option.attr("dictionary", targetWho.addresses1[i].label);
                                $option.val(targetWho.addresses1[i].where);
                                //Append
                                $dropDown.append($option);
                            }
                        }break;
                    }

                    $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/address") +"']").prop("selected",true);



                    //populate function dropdown
                    $dropDown = $componentProperties.find("[eve-manager-id='bticino/function']");
                    for(var i=0; i<targetWho.functions.length; ++i){

                        if(targetWho.functions[i].fid == 14) {
                            var $option = $("<option></option>");
                            $option.text(_D(targetWho.functions[i].label));
                            $option.attr("title", _D(targetWho.functions[i].label));
                            $option.attr("dictionary", targetWho.functions[i].label);
                            $option.val(targetWho.functions[i].fid);

                            //Append
                            $dropDown.append($option);
                        }
                    }

                    $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/function") +"']").prop("selected",true);

                }

            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }

        });



        // Modbus
        $.ajax({
            url: "./declarations/modbus/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for(var i=0; i<json.unit_id.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-unit-id") +"']").prop("selected",true);

                //switch_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for(var i=0; i<json.switch_transform_type.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.switch_transform_type[i].label));
                    $option.attr("title", _D(json.switch_transform_type[i].label));
                    $option.attr("dictionary", json.switch_transform_type[i].label);
                    $option.val(json.switch_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-transform-type") +"']").prop("selected",true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for(var i=0; i<json.read_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-function-id") +"']").prop("selected",true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for(var i=0; i<json.write_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-function-id") +"']").prop("selected",true);

            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });

        // ModbusTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));

        // ModbusTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-multiplier"));


        // ModbusRTUTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

        // ModbusRTUTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));

    };
}
catch(err){
    console.error(err);
}
