/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set html name
    	$Elem = $("#"+ oComponent.id +" .components-text");
    	$Elem.text(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='history']");
    	$Elem.prop("checked",oComponent.getParamVal("history"));
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
    	$Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='cache']");
    	$Elem.prop("checked",oComponent.getParamVal("cache"));

        var $Elem = $componentProperties.find("[eve-manager-id='nolabel']");
        $Elem.prop("checked", oComponent.getParamVal("nolabel") );

        //Set tags

        $Elem = $componentProperties.find("[eve-manager-id='tags']");
        var resTags = oComponent.getParamVal("tags");
        var $selectedTags="[";
        console.log(resTags);
        if (resTags!="")
        {
            var res=resTags.split("|");

            for (var k=0;k<res.length;k++)
            {
                if ($selectedTags.length>1) $selectedTags+=",";
                $selectedTags+="{\"id\": \""+res[k]+"\", \"text\": \""+res[k]+"\"}";
            }


        }

        $selectedTags+="]";
        // console.log($selectedTags);
        $Elem.select2("data",jQuery.parseJSON( $selectedTags ));
        // console.log($Elem);
       
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        //Set step
        $Elem = $componentProperties.find("[eve-manager-id='step']");
        $Elem.val(oComponent.getParamVal("step"));

        $Elem = $componentProperties.find("[eve-manager-id='min']");
        $Elem.val(oComponent.getParamVal("min"));

        $Elem = $componentProperties.find("[eve-manager-id='max']");
        $Elem.val(oComponent.getParamVal("max"));

        $Elem = $componentProperties.find("[eve-manager-id='digits']");
        $Elem.val(oComponent.getParamVal("digits"));

        $Elem = $componentProperties.find("[eve-manager-id='suffix']");
        $Elem.val(oComponent.getParamVal("suffix"));


        //Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.val(oComponent.getParamVal("knx/virtual-feedback"));


        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );



        var $Elem = $componentProperties.find("[eve-manager-id='ghost/updateonchange']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/updateonchange") );



        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
        
        /** Vivaldi */
		
		//Set Vivaldi products
        $.ajax({
            url: "./declarations/vivaldi/devices.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
				
                //Parsing Vivaldi Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("tuner") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("Vivaldi",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
				
				//Disable if exist one choice
				$dropDown.prop("disabled",true);
                
                //Select currently PID
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-pid") +"']");
                var oVivaldiDevice = $selected.data("Vivaldi");
                
				//Select vivaldi device
                $selected.prop("selected",true);
				
				//Fill RC20 address
				$dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-id']");
                for(var i=0; i<oVivaldiDevice.idList.length; ++i){
                    var $option = $("<option></option>");
					$option.text(oVivaldiDevice.idList[i]);
					$option.val(oVivaldiDevice.idList[i]);
                    
					$dropDown.append($option);
                }
				
				var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-id") +"']");
				$selected.prop("selected",true);
				
				//Fill Function ID
				$dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']");
                for(var i=0; i<oVivaldiDevice.fidList.length; ++i){
					if(oVivaldiDevice.fidList[i].fid == 9) {
					    var $option = $("<option></option>");
						$option.text(oVivaldiDevice.fidList[i].label);
						$option.val(oVivaldiDevice.fidList[i].fid);
                    
						$dropDown.append($option);
					}

                }
				
				var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-fid") +"']");
				$selected.prop("selected",true);
				
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
        
        /** Aernova */
        
        //Set Aernova modes
        $.ajax({
            url: "./declarations/aernova/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                $dropDown = $componentProperties.find("[eve-manager-id='aernova/mode']");
                //Parsing Aernova modes
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                   	if(json[i].fid == 6 || json[i].fid == 7 || json[i].fid == 8 || json[i].fid == 63 || json[i].fid == 71 || json[i].fid == 72) {
                        $option.text(_D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.attr("dictionary", json[i].label);
                        $option.val(json[i].fid);
                        $option.data("Aernova",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("aernova/mode") +"']");
				$selected.prop("selected",true);			
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });
		
        $Elem = $componentProperties.find("[eve-manager-id='aernova/address']");
        $Elem.val(oComponent.getParamVal("aernova/address"));    
        
        /** ODIC */
       	$.ajax({
            url: "./declarations/odic/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
				
				//populate variable id dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='odic/variableid']");
                for(var i=0; i<json.variableId.length; ++i){
                	
                    var $option = $("<option></option>");	                   	
                    $option.text(_D(json.variableId[i].label));
                    $option.attr("title", _D(json.variableId[i].label));
                    $option.attr("dictionary", json.variableId[i].label);
                    $option.val(json.variableId[i].value);
                    
                    //Append
                    $dropDown.append($option);
                    
                }
	            $selected = $dropDown.find("[value='"+ oComponent.getParamVal("odic/variableid") +"']").prop("selected",true);
	            
	           	//populate integer dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='odic/type']");
                for(var i=0; i<json.type.length; ++i){
                	
                    var $option = $("<option></option>");	                   	
                    $option.text(_D(json.type[i].label));
                    $option.attr("title", _D(json.type[i].label));
                    $option.attr("dictionary", json.type[i].label);
                    $option.val(json.type[i].value);
                 	
                    //Append
                    $dropDown.append($option);
                    
                }
	            $selected = $dropDown.find("[value='"+ oComponent.getParamVal("odic/type") +"']").prop("selected",true);
	            
	           	var type = oComponent.getParamVal("odic/type");
	            if(type == 0) {
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyInt();});
				}
				if(type == 1) {
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
	            	$Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
	            	$Elem.on("keypress", function (evt) {return bigh.onlyFloat();});
				}        			
            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });

        $Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
        $Elem.val(oComponent.getParamVal("odic/rmin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
        $Elem.val(oComponent.getParamVal("odic/rmax"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
        $Elem.val(oComponent.getParamVal("odic/smin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
        $Elem.val(oComponent.getParamVal("odic/smax"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
        $Elem.val(oComponent.getParamVal("odic/tmin"));
        
        $Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
        $Elem.val(oComponent.getParamVal("odic/tmax"));

        // Modbus
        $.ajax({
            url: "./declarations/modbus/functions.json",
            cache: false,
            dataType: "json",
            success: function(json){
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for(var i=0; i<json.unit_id.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-unit-id") +"']").prop("selected",true);

                //switch_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for(var i=0; i<json.switch_transform_type.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.switch_transform_type[i].label));
                    $option.attr("title", _D(json.switch_transform_type[i].label));
                    $option.attr("dictionary", json.switch_transform_type[i].label);
                    $option.val(json.switch_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-transform-type") +"']").prop("selected",true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for(var i=0; i<json.read_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-function-id") +"']").prop("selected",true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for(var i=0; i<json.write_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-function-id") +"']").prop("selected",true);

            },
            error: function(jqXHR,textStatus,errorThrown){
                console.error(textStatus);
            }
        });

        // ModbusTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));

        // ModbusTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-multiplier"));


        // ModbusRTUTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

        // ModbusRTUTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));

    };
}
catch(err){
    console.error(err);
}
