/** Update component component properties */
try{
    
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(oComponent){
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
    	
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}
    	
    	//Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
    	
    	//Set local url
        $Elem = $componentProperties.find("[eve-manager-id='local-url']");
        $Elem.val(oComponent.getParamVal("local-url"));
        
        //Set remote url
        $Elem = $componentProperties.find("[eve-manager-id='remote-url']");
        $Elem.val(oComponent.getParamVal("remote-url"));
        
        //Set local url list
        $Elem = $componentProperties.find("[eve-manager-id='local-url-list']");
        $Elem.val(oComponent.getParamVal("local-url-list"));
    	
    	//Set multitouch
        $Elem = $componentProperties.find("[eve-manager-id='multitouch']");
        $Elem.prop("checked",oComponent.getParamVal("multitouch"));
    	
    	//Disable gateway
    	$("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );
    };
}
catch(err){
    console.error(err);
}
