/** Eve Manager Initial operations
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 */ 
"use strict";

var $document = $(document);
var $window = $(window);
var QT = new Server();

window["eve"] = new Object();
QT.eve.disconnect();

/** Model namespace
 *
 */
var model = {
    //Status of current project
    connectedUser: undefined,
    name: "",
    version: "",
    instance: new Model()
};

/** Presenter namespace
 *
 */
var presenter = {

    /** Windows manager */
    windows:{
        alert:              new Window("alert"),
        addComponentsList:  new Window("addComponentsList"),
        confirm:            new Window("confirm"),
        loader:             new Window("loader"),
        scenarioEditor:     new Window("scenarioEditor"),
        iconEditor:         new Window("iconEditor"),
        componentEditor:    new Window("componentEditor"),
        etsProject:         new Window("etsProject"),
        databaseManager:    new Window("databaseManager"),
        userManager:        new Window("userManager"),
        logicEditor:        new Window("logicEditor"),
        weekEditor:         new Window("weekEditor"),
        yearEditor:         new Window("yearEditor")
    },
    getWindow: function(winId){
        if(this.windows[winId] == undefined){
            console.error("Window: "+ winId +" not defined");
            return undefined;
        }

        return this.windows[winId];
    },

    /** Menu manager */
    menu: new MenuUIManager(),

    /** Events manager */
    events: new EventManager(),
    preferences: new PreferencesManager(),
    application: new Presenter()
};

/** Initialize MVP architecture
 *
 */                                                                       //Desktop communication
//var eveManager = new Model();															     //Create model instance
//var application = new Presenter();                                                           //Presenter class instance

var eveManager = model["instance"];															 //Create model instance
var application = presenter.application;                                                     //Presenter class instance

var _D = application.Dictionary.getName;

//presenter.preferences.init();
application.init();

/** On window resize function */
$window.resize(PubSub.View.Resize.Window);											        //On window resize

/** Before leave the page */
/*$window.bind("beforeunload", function(e){
});*/

/** Document ready function */
$document.ready(function(){
    
    // Resize window tabs
    $.publish("/view/window/resize");

	/** WRITE TEST CODE HERE */

	$.getScript("./script/test.js");

    //application.addComponent({ type: "switch", gateway: application.addGateway() });
    //application.addComponent({ type: "info" });
    //application.addComponent({ type: "slider" });
    //application.addComponent({ type: "combo" });

});

function getStyleSheetPropertyValue(selectorText, propertyName) {
    // search backwards because the last match is more likely the right one
    for (var s= document.styleSheets.length - 1; s >= 0; s--) {
        var cssRules = document.styleSheets[s].cssRules ||
            document.styleSheets[s].rules || []; // IE support
        for (var c=0; c < cssRules.length; c++) {
            if (cssRules[c].selectorText === selectorText)
                return cssRules[c].style[propertyName];
        }
    }
    return null;
}