/** Confirm class (extends Window class)
 *
 * @class Confirm
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 * 
 */
"use strict";

function Confirm(oWindow){
	
	var self = this;
	
	/**
	 *
     *
	 */
	var init = function(){
        console.log("%cWindow - Confirm class initialization (extends Window class)","color:green");

        //Create jQuery UI dialog
        m_$element.dialog({
            closeOnEscape: true,
            //title: "Alert",
            title: _D("Message"),
            minWidth: 250,
            modal: false,
            resizable: false,
            autoOpen: false,
            close: self.onHide
        });
        
        m_$element.find("button").button();
        
        m_$element.on("click","button[type='submit']",function(e){
            self._submit();
            m_$element.dialog("close");
        });

        m_$element.on("click",".cancel",function(e){
            m_$element.dialog("close");
        });
        
        m_$element.find(".message").css("display","block");
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element;
    
	/** Show icon editor window
	 */
	this.show = function(oParam){
	    
	    m_$element.find(".message").html(oParam.message);
        self._submit = oParam.callback;
	    
	    m_$element.dialog("open");
	};
	
	/** Hide icon editor window and closing operation
     */
    this.hide = function(e,ui){
        self._submit = function(){};
    };
	
	/** Hide icon editor window and closing operation
	 */
	this.onHide = function(e,ui){
	    //m_$element.find(".message").css("display","block");
        m_$element.find(".message").css("display","block").empty().removeClass("ui-state-error");
	    m_$element.find(".ui-icon").hide();
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };

    /** Submit confirm
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this._submit = function(){};
}