/** etsProject class (extends Window class)
 *
 * @class etsProject
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function etsProject(oWindow){
	
	var self = this;
	
	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - etsProject class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            create: function(e,ui){
                /*$(this).find("[knx-group-address]").draggable({
                    helper: "clone"
                });*/
                m_$element.find("button").button();
            },
            open: self._createTree,
            /*open: function(e,ui){
                // transform in tree
                $(this).find(".project").jstree({
                    // the `plugins` array allows you to configure the active plugins on this instance
                    plugins: ["themes","json_data","types","search","dnd"],
                    //plugins: ["themes","json_data","types","search"],
                    // each plugin you have included can have its own config object
                    core: {
                        html_titles: true,
                        animation: false,
                        load_open: true,
                        strings: { loading : "Loading ...", new_node : "New node" }
                    },
                    themes: {
                        url: "./css/plugin/jsTree/default/style.css",
                        theme: "default",
                        dots: false
                    },
                    types: {
                        valid_children : ["knx-main-group"],
                        types: {
                            "knx-main-group":{
                                icon: {
                                    image:"./css/plugin/jsTree/default/d.png",
                                    position: "-72px -54px"
                                },
                                max_depth: 2,
                                valid_children: ["knx-main-group","knx-intermediate-group"]
                            },
                            "knx-intermediate-group":{
                                icon: {
                                    image:"./css/plugin/jsTree/default/d.png",
                                    position: "-54px -54px"
                                },
                                max_depth: 1,
                                valid_children: ["knx-group"]
                            },
                            "knx-group":{
                                icon: {
                                    image:"./css/plugin/jsTree/default/d.png",
                                    position: "-72px -36px"
                                },
                                max_depth: 0,
                                valid_children: "none",
                                use_data: true
                            }
                        }
                    },
                    dnd:{
                        drag_target: false,
                        drop_target: "#componentproperties .container [eve-manager-id='knx/write-address'], #componentproperties .container [eve-manager-id='knx/feedback-address']",
                        drop_finish: function(oData){
                            console.error("sxacx");
                            var targetAttrId = oData.r.attr("eve-manager-id");
                            var $inputAddress = $("#componentproperties .container [eve-manager-id='"+ targetAttrId +"']");
                            var groupAddress = oData.o.attr("knx-group-address");
                            var aSplitAddress = groupAddress.split("/");
                            var groupName = oData.o.find(".name").text();
                            
                            $inputAddress[0].value = aSplitAddress[0];
                            $inputAddress[1].value = aSplitAddress[1];
                            $inputAddress[2].value = aSplitAddress[2];
                            
                            $($inputAddress[0]).trigger("onkeyup");
                            $($inputAddress[1]).trigger("onkeyup");
                            $($inputAddress[2]).trigger("onkeyup");
                            
                            //Set name
                            if(targetAttrId == "knx/write-address"){
                                $("#componentproperties .container [eve-manager-components='mainframe'] [eve-manager-id='name']").val(groupName);
                                $("#componentproperties .container [eve-manager-components='mainframe'] [eve-manager-id='name']").trigger("onkeyup");
                            }
                        }
                    },
                    json_data:{
                        ajax: {
                            url: "../project/assets/imports/knx/project.json",
                            dataType: "json",
                            cache: false,
                            //dataType: "text",
                            success: function(data,testStatus){
                                return data;
                            },
                            error: function(jqXHR,textStatus,errorThrown){
                                console.error(jqXHR);
                            }
                        }
                    }
                });
            },*/
            minHeight: 200,
            minWidth: 350,
            height: 400,
            width: 600,
            autoOpen: false,
            title: "ETS project",
            modal: false,
            resizable: true,
            close: m_oWindow.hide
        });
        
        //On submit search form
        m_$element.on("submit","form",function(e){
            var $jsTree = $("#etsProject").find(".project");
            var val = $(this).find("input").val();
            
            $jsTree.jstree("search",val);
        });
        
        //Enable/disable filter
        m_$element.on("change","form input[type='checkbox']",function(e){
            $.publish("/view/imported/projects/knx/refresh/address");
        });
        
        //On submit search form
        m_$element.on("click",".load-file",function(e){
            //Save globally file content
            //window["knx/opc"] = QT.readAnyFile("(*.esf *.xml)");
            window["knx/opc"] = QT.readAnyFile("(*.esf)");
            console.warn("Important: check file extention for choose correct parser");
            
            //OPC server parser
            $.getScript("./parsers/knx/opc-server.js");
            
            //Create tree
            self._createTree(e);
        });
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element;
	
	/** Show icon editor window
	 */
	this.show = function(oParam){
	    if(m_$element == undefined || m_$element.length < 1){
	        console.error("Window object etsProject not be initialized");
	        return;
	    }
	    
	    m_$element.dialog("open");
	};
	
	/** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    
	    //Show hidden elements
        m_$element.find(".actions [type='button']").show();
	    
	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
    /** Interactions methods */
   
       
    
    /** Create Tree
     * 
     */
    this._createTree = function(e){
        // transform in tree
        m_$element.find(".project").jstree({
            // the `plugins` array allows you to configure the active plugins on this instance
            plugins: ["themes","json_data","types","search","dnd"],
            //plugins: ["themes","json_data","types","search"],
            // each plugin you have included can have its own config object
            core: {
                html_titles: true,
                animation: false,
                load_open: true,
                strings: { loading : "Loading ...", new_node : "New node" }
            },
            themes: {
                url: "./css/plugin/jsTree/default/style.css",
                theme: "default",
                dots: false
            },
            types: {
                valid_children : ["knx-main-group"],
                types: {
                    "knx-main-group":{
                        icon: {
                            image:"./css/plugin/jsTree/default/d.png",
                            position: "-72px -54px"
                        },
                        max_depth: 2,
                        valid_children: ["knx-main-group","knx-intermediate-group"]
                    },
                    "knx-intermediate-group":{
                        icon: {
                            image:"./css/plugin/jsTree/default/d.png",
                            position: "-54px -54px"
                        },
                        max_depth: 1,
                        valid_children: ["knx-group"]
                    },
                    "knx-group":{
                        icon: {
                            image:"./css/plugin/jsTree/default/d.png",
                            position: "-72px -36px"
                        },
                        max_depth: 0,
                        valid_children: "none",
                        use_data: true
                    }
                }
            },
            dnd:{
                drag_target: false,
                //drop_target: "#componentproperties .container [eve-manager-id='knx/write-address'],#componentproperties .container [eve-manager-id='knx/feedback-address']",
                //drop_target: "#componentproperties .container [eve-manager-id*='write-address'],#componentproperties .container [eve-manager-id*='feedback-address']",
				drop_target: "#componentproperties .container [eve-manager-id*='write-address'],#componentproperties .container [eve-manager-id*='feedback-address'],#componentproperties .container [eve-manager-id='name']",
                drop_finish: function(oData){
                    var targetAttrId = oData.r.attr("eve-manager-id");
					var groupsName = oData.o.find(".name");
					if(targetAttrId == 'name'){
						var $name = $("#componentproperties .container [eve-manager-id='name']");
						$name.val(groupsName[0].innerHTML);
						$name.trigger("onkeyup");
						return;
					}
					
                    var $inputAddress = $("#componentproperties .container [eve-manager-id='"+ targetAttrId +"']");
                    var groupAddress = oData.o.attr("knx-group-address");
                    var aSplitAddress = groupAddress.split("/");
                    
                    $inputAddress[0].value = aSplitAddress[0];
                    $inputAddress[1].value = aSplitAddress[1];
                    $inputAddress[2].value = aSplitAddress[2];
                    
                    $($inputAddress[0]).trigger("onkeyup");
                    $($inputAddress[1]).trigger("onkeyup");
                    $($inputAddress[2]).trigger("onkeyup");
                    
                    //Set name
                    /*if(targetAttrId == "knx/write-address"){
                        $("#componentproperties .container [eve-manager-components='mainframe'] [eve-manager-id='name']").val(groupName);
                        $("#componentproperties .container [eve-manager-components='mainframe'] [eve-manager-id='name']").trigger("onkeyup");

                        //Probably doesn't exist
                        var $inputFBAddress = $("#componentproperties .container [eve-manager-id='knx/feedback-address']")
                        var $feedback = m_$element.find(".project .name:contains(FB_"+ groupName +")");
                        var fbAddr = $feedback.parents("li").attr("knx-group-address");
                        var aSplitFBAddress = fbAddr.split("/");

                        $inputFBAddress[0].value = aSplitFBAddress[0];
                        $inputFBAddress[1].value = aSplitFBAddress[1];
                        $inputFBAddress[2].value = aSplitFBAddress[2];

                        $($inputFBAddress[0]).trigger("onkeyup");
                        $($inputFBAddress[1]).trigger("onkeyup");
                        $($inputFBAddress[2]).trigger("onkeyup");
                    }*/
                }
            },
            json_data:{
                ajax: {
                    url: "../project/assets/imports/knx/project.json",
                    dataType: "json",
                    cache: false,
                    //dataType: "text",
                    success: function(data,testStatus){
                        return data;
                    },
                    error: function(jqXHR,textStatus,errorThrown){
                        m_$element.find(".jstree-loading").hide();
                        console.error(jqXHR);
                    }
                }
            }
        });
    };

}