/** iconEditor class (extends Window class)
 *
 * @class iconEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function iconEditor(oWindow){
	
	var self = this;
	
	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - iconEditor class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            height: "auto",
            width: "auto",
            autoOpen: false,
            modal: true,
            resizable: false,
            close: m_oWindow.hide,
            title: _D("Icon Editor"),
            create: function(e,ui){
                $(this).find(".actions button").button();
            }
        });
        
        //On enable/disable color
        m_$element.on("change",".enableColors",self._colorEnabling);
        
        //Set colorpickers actions OLD
        /*m_$element.find(".color").ColorPicker({
            onBeforeShow: function(pickerElem){
                //Background color described as "rgb(R,G,B)"
                //TODO check "bigh.textRgb2hex" function
                //console.error($(this).css("background-color"));
                $(this).ColorPickerSetColor(bigh.textRgb2hex($(this).css("background-color")));
            },
            //On choose color
            onSubmit: self._chooseColor,
            //onChange: self._chooseColor
            onChange: function(param,hex,hue){
                //console.log(this);
                $(this).find(".colorpicker_current_color").css("background-color","rgb("+hue.r+","+hue.g+","+hue.b+")");
                self._chooseColor(param,hex,hue,m_$element.find(".color")[0]);
                //$(this).trigger("submit");
            }
        });*/

        m_$element.find(".color").colpick({
            onBeforeShow: function(pickerElem){
                //Background color described as "rgb(R,G,B)"
                //TODO check "bigh.textRgb2hex" function
                //console.error($(this).css("background-color"));
                //$(this).ColorPickerSetColor(bigh.textRgb2hex($(this).css("background-color")));
                //$(this).colpickSetColor(bigh.textRgb2hex($(this).css("background-color")));
                $(this).colpickSetColor(bigh.textRgb2hex($(this).css("border-right-color")));

                //console.error(pickerElem);
                //$(this).css('border-color',bigh.textRgb2hex($(this).css("background-color")));
            },
            //On choose color
            layout:'hex',
            //onSubmit: self._chooseColor,
            colorScheme:'dark',
            submit:false,
            //flat: true,
            //onChange: self._chooseColor
            //onChange: function(param,hex,hue){
            onChange: function(hsb,hex,rgb,el,bySetColor){

                /*console.error(hsb);
                console.log(hex);
                console.log(rgb);
                console.log(el);
                console.log(bySetColor);*/

                $(el).css('border-right-color','#'+hex);
                // Fill the text box just if the color was set using the picker, and not the colpickSetColor function.
                if(!bySetColor)
                    $(el).val(hex);
                self._chooseColor(hsb,hex,rgb,m_$element.find(".color")[0]);
                return;
                //console.log(this);
                $(this).find(".colorpicker_current_color").css("background-color","rgb("+hue.r+","+hue.g+","+hue.b+")");
                self._chooseColor(param,hex,hue,m_$element.find(".color")[0]);
                //$(this).trigger("submit");
            }
        }).keyup(function(){
            $(this).colpickSetColor(this.value);
        });
        
        //On choose icon
        m_$element.on("click",".icon",self._chooseIcon);
        
        //On Submit
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".actions [type='reset']",function(e){
            m_oWindow.hide();
        });
    
        //On change
        $("#icons-picker").on("change",".pans-selector",function(e){
            var $picker = $("#icons-picker");
            $picker.find("ul").hide();
            $picker.find("[application-pan-id='"+ $(this).val() +"']").show();
        });
        
        $("#icons-picker").on("dialogopen",function(e){
            //$(this).find(".pans-selector [value='"+ m_oIcon.srcId +"']").trigger("click");
            $(this).find(".pans-selector").trigger("change");
        });
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element = oWindow;
    
    /** Edited icon
     * @type {object}
     */
    var m_oIcon;
	
	/** Show icon editor window
	 */
	this.show = function(oParam){
	    var oNode = m_oWindow.getActiveNode();
	    var oData = oNode.getData();
        //console.log(oNode);
	    
	    //oUIComponent icon editor operations
        if(oData instanceof UIComponent){
            var oIcon = oData.getParamVal("icon");
            m_oIcon = jQuery.extend(true,{},oIcon);
            
            var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
            var coloreHex = bigh.textRgb2hex(coloreRBG);
            var backgroundIcon = (m_oIcon.position.x*0.5)+"px "+(m_oIcon.position.y*0.5)+"px";
            
            //Set checkbox enable colors
            m_$element.find(".enableColors").prop("checked",(m_oIcon.enableColors != undefined)?m_oIcon.enableColors:false);
            
            //Set current icon color and set associated icon as data
            //m_$element.find(".color").css("background-color",coloreRBG);
            m_$element.find(".color").css("border-right-color",coloreHex);

            if(!m_$element.find(".enableColors").prop("checked")){
                //Disable
                m_$element.find(".color").addClass("disabled");
                m_$element.find(".icon").unbind("click");
            }
            
            //Trigger change event
            m_$element.find(".enableColors").trigger("change");
            
            //Set current icon position
            //m_$element.find(".icon").css("background-position",backgroundIcon);
            
            //Hide remove button
            m_$element.find(".actions [type='button']").hide();
            
            //Set name
            m_$element.find(".component-name").text(oData.getParamVal("name"));
        }
	    //oComponent icon editor operations
	    else if(oData instanceof Component){
	        var aIcons = oData.getParamVal("icons");
	        var status = oParam.status;
	        
	        //Search correct icon
	        for(var i=0; i<aIcons.length; ++i){
	            if(aIcons[i].status == status){
	                //Clone icon object
	                m_oIcon = jQuery.extend(true,{},aIcons[i]);
	                break;
	            }
	        }

            //console.error(m_oIcon.color);
            var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
            var coloreHex = bigh.textRgb2hex(coloreRBG);
            //console.error(coloreHex);
	        
	        /*
	        var oPan = application.ResoucesManager.getIconsPanById(m_oIcon.srcId);
	        var iconIndex = parseInt( (Math.abs(m_oIcon.position.x)/m_oIcon.size.w) + (Math.abs(m_oIcon.position.y)/m_oIcon.size.h)*(m_oIcon.setSize.w/m_oIcon.size.w) ,10);
	        var img = document.getElementById(m_oIcon.srcId);
	        var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
	        var scale = 1;
            
            if(oPan["params"]["iconsWidth"] > 64){
                scale = 0.5;
            }
	        
	        var backgroundIcon = (m_oIcon.position.x*scale)+"px "+(m_oIcon.position.y*scale)+"px";
	        */
	        
	        //Set checkbox enable colors
	        m_$element.find(".enableColors").prop("checked",(m_oIcon.enableColors != undefined)?m_oIcon.enableColors:false);
	        
	        //Set current icon color and set associated icon as data
	        //m_$element.find(".color").css("background-color",coloreRBG);
            m_$element.find(".color").css("border-right-color",coloreHex).val(coloreHex.substr(1));

	        if(!m_$element.find(".enableColors").prop("checked")){
	            //Disable
	            m_$element.find(".color").addClass("disabled");
	            m_$element.find(".icon").unbind("click");
	        }
	        
	        //Trigger change event
            m_$element.find(".enableColors").trigger("change");
	        
	        //Set current icon position
	        
	        //Find icon from icon picker
            //var oStyle = $("#icons-picker").find("[application-pan-id='"+ m_oIcon.srcId +"'] li").eq(iconIndex).find("span").attr("style");
	        //m_$element.find(".icon").attr("style",oStyle);
	        
	        
	        
	        /*
	         *
	         NEW CODE
	        icon.css("display","inline-block");
            $icon.css("width",(oPan["params"]["iconsWidth"] * scale) +"px");
            $icon.css("height",(oPan["params"]["iconsHeight"] * scale) +"px");
            $icon.css("background-repeat","no-repeat");
            $icon.css("background-size",(oPan["params"]["imgWidth"] * scale) +"px "+ (oPan["params"]["imgHeight"] * scale) +"px");
            $icon.css("background-image","url('"+ oPan["params"]["src"] +"')");
            $icon.css("background-position",(oPan["params"]["_positions"][i]["x"] * scale) +"px "+ (oPan["params"]["_positions"][i]["y"] * scale) +"px");
            
            */
	        //m_$element.find(".icon").css("background-position",backgroundIcon);
	        
	        //Hide remove button
	        m_$element.find(".actions [type='button']").hide();
	        
	        //Set name
	        m_$element.find(".component-name").text(oData.getParamVal("name"));
	    }
	    else if(oData instanceof Map){
	        var oIcon = oData.icon;
	        m_oIcon = jQuery.extend(true,{},oIcon);
            var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
            var coloreHex = bigh.textRgb2hex(coloreRBG);

            //Set checkbox enable colors
            m_$element.find(".enableColors").prop("checked",(m_oIcon.enableColors != undefined)?m_oIcon.enableColors:false);

            //m_$element.find(".color").css("background-color",coloreRBG);
            m_$element.find(".color").css("border-right-color",coloreHex);

            //Set current icon color and set associated icon as data
            //m_$element.find(".color").css("background-color",coloreRBG);

            if(!m_$element.find(".enableColors").prop("checked")){
                //Disable
                m_$element.find(".color").addClass("disabled");
                m_$element.find(".icon").unbind("click");
            }

            //Trigger change event
            m_$element.find(".enableColors").trigger("change");
	    }
        else if(oData instanceof MapComponent){

            var aIcons = oData.icons;

            for(var i=0; i<aIcons.length;++i){
                if(aIcons[i].status == oParam.iconstatus){
                    m_oIcon = jQuery.extend(true,{},aIcons[i]);
                }
            }

	        //m_oIcon = jQuery.extend(true,{},oIcon);
            var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
            var coloreHex = bigh.textRgb2hex(coloreRBG);

            //Set checkbox enable colors
            m_$element.find(".enableColors").prop("checked",(m_oIcon.enableColors != undefined)?m_oIcon.enableColors:false);

            //m_$element.find(".color").css("background-color",coloreRBG);

            //Set current icon color and set associated icon as data
            m_$element.find(".color").css("background-color",coloreRBG);

            if(!m_$element.find(".enableColors").prop("checked")){
                //Disable
                m_$element.find(".color").addClass("disabled");
                m_$element.find(".icon").unbind("click");
            }

            //Trigger change event
            m_$element.find(".enableColors").trigger("change");
	    }
        else if(oData instanceof User){

            var oIcon = oData.logoutIcon;
            m_oIcon = jQuery.extend(true,{},oIcon);
            var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
            var coloreHex = bigh.textRgb2hex(coloreRBG);

            //Set checkbox enable colors
            m_$element.find(".enableColors").prop("checked",(m_oIcon.enableColors != undefined)?m_oIcon.enableColors:false);

            //m_$element.find(".color").css("background-color",coloreRBG);
            m_$element.find(".color").css("border-right-color",coloreHex);

            //Set current icon color and set associated icon as data
            //m_$element.find(".color").css("background-color",coloreRBG);

            if(!m_$element.find(".enableColors").prop("checked")){
                //Disable
                m_$element.find(".color").addClass("disabled");
                m_$element.find(".icon").unbind("click");
            }

            //Trigger change event
            m_$element.find(".enableColors").trigger("change");
        }

        //console.error(m_oIcon);

	    var oPan = application.ResoucesManager.getIconsPanById(m_oIcon.srcId);
        var iconIndex = parseInt( (Math.abs(m_oIcon.position.x)/m_oIcon.size.w) + (Math.abs(m_oIcon.position.y)/m_oIcon.size.h)*(m_oIcon.setSize.w/m_oIcon.size.w) ,10);
        var img = document.getElementById(m_oIcon.srcId);
        var coloreRBG = "rgb("+m_oIcon.color.R+","+m_oIcon.color.G+","+m_oIcon.color.B+")";
        var scale = 1;
        
        if(oPan["params"]["iconsWidth"] > 64){
            scale = 0.5;
        }
        
        var backgroundIcon = (m_oIcon.position.x*scale)+"px "+(m_oIcon.position.y*scale)+"px";
	    
	    //Find icon from icon picker
        var oStyle = $("#icons-picker").find("[application-pan-id='"+ m_oIcon.srcId +"'] li").eq(iconIndex).find("span").attr("style");
        m_$element.find(".icon").attr("style",oStyle);
	    
	    m_$element.dialog("open");
	};
	
	/** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    m_oIcon = undefined;
	    
	    //Show hidden elements
        m_$element.find(".actions [type='button']").show();
	    
	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
    /** Interactions methods */
    
    /** Enable/disable color
     * 
     */
    this._colorEnabling = function(e){
        var $this = m_$element.find(".enableColors");
        
        m_oIcon.enableColors = $this.prop("checked");
        
        //Enable
        if(m_oIcon.enableColors){
            //Set colorpickers actions
            m_$element.find(".color").css("visibility","visible");
        }
        //Disable
        else{
            m_$element.find(".color").css("visibility","hidden");
        }
    };
    
    /** Chose color
     * 
     */
    this._chooseColor = function(param,hex,hue,HTMLelem){

        //console.error(hex);

        /*console.log(param);
        console.log(hex);
        console.log(hue);
        console.log(HTMLelem);*/
        //return;
        m_oIcon.color = {
            R: hue.r,
            G: hue.g,
            B: hue.b
        };
        
        //Change item background color
        //$(HTMLelem).css("background-color","#"+ hex);
        $(HTMLelem).css("border-right-color","#"+ hex);

        //m_$element.find(".color").css("border-right","#"+ hex);

        //m_$element.find();
    };
    
    /** Chose icon 
     * 
     */
    this._chooseIcon = function(e){
        var $this = m_$element.find(".icon");
        $("#icons-picker").dialog("open");
        $("#icons-picker").parent().css("top",($this.offset().top + $this.outerHeight())+"px").css("left",($this.offset().left)+"px");
        
        $("#icons-picker li").one("click",function(){
            var $this = $(this);
            var strPanId = $this.parent().attr("application-pan-id");
            var oPan = application.ResoucesManager.getIconsPanById(strPanId);
            var iconIndex = $this.parent().find("li").index($this);
            
            //Get Position
            var iColumn = (oPan["params"]["imgWidth"] / oPan["params"]["iconsWidth"]);
            var iLines = (oPan["params"]["imgHeight"] / oPan["params"]["iconsHeight"]);
            
            var Xpos = (-1) * (iconIndex % iColumn) * oPan["params"]["iconsWidth"];
            var Ypos = (-1) * parseInt(iconIndex / iColumn,10) * oPan["params"]["iconsHeight"];
            
            //console.log("Xpos: "+ Xpos);
            //console.log("Ypos: "+ Ypos);
            //console.error((iconIndex % iColumn));
            
            /*
            var strBackground = $this.find("span").css("background-position");
            var strBackgroundSrc = $this.find("span").css("background-image");
            var aBackground = strBackground.split(" ");
            
            m_oIcon.position = {
                x: (parseInt(aBackground[0],10)*2),
                y: (parseInt(aBackground[1],10)*2)
            };
            */
           
            //m_$element.find(".icon").css("background-position",strBackground);
            m_$element.find(".icon").attr("style",$this.find("span").attr("style"));
            
            //Save to icon object
            m_oIcon.srcId = strPanId;
            m_oIcon.position = { x: Xpos, y: Ypos };
            m_oIcon.size = { h: oPan["params"]["iconsHeight"], w: oPan["params"]["iconsWidth"] };
            m_oIcon.setSize = { h: oPan["params"]["imgHeight"], w: oPan["params"]["imgWidth"] };
            
            $("#icons-picker").dialog("close");
        });
    };
    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData = oNode.getData();
        
        //oUIComponent icon editor operations
        if(oData instanceof UIComponent){
            var oUIComponent = oData;
            var oIcon = oData.getParamVal("icon");
            
            $.extend(true,oIcon,m_oIcon);
            
            //Set model and view
            $.publish("/model/uicomponents/"+ oUIComponent.id +"/update/parameter",[oUIComponent,"icon",oIcon]);
            $.publish("/view/uicomponents/"+ oUIComponent.id +"/refresh/parameter",[oUIComponent,"icon"]);
        }
        //oComponent icon editor operations
        else if(oData instanceof Component){
            var oComponent = oData;
            var aIcons = oData.getParamVal("icons");

            //console.log(aIcons);
            
            //Search and update icon
            for(var i=0; i<aIcons.length; ++i){
                if(m_oIcon.status == aIcons[i].status){
                    $.extend(true,aIcons[i],m_oIcon);
                    //aIcons[i] = m_oIcon;
                    break;
                }
            }
            
            //Set model and view
            $.publish("/model/components/"+ oComponent.id +"/update/parameter",[oComponent,"icons",aIcons]);
            $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

            //console.error(oComponent);
        }
        if(oData instanceof Map){
            var oMap = oData;
            var oIcon = oData.icon;

            $.extend(true,oIcon,m_oIcon);

            //Set model and view
            $.publish("/model/uicomponent/map/"+ oMap.id +"/update/parameter",[oMap,"icon",oIcon]);
            $.publish("/view/uicomponent/map/"+ oMap.id +"/refresh/parameter",[oMap,"icon"]);
        }
        if(oData instanceof MapComponent){
            var oMapComponent = oData;
            //var oIcon = oData.icon;

            //$.extend(true,oIcon,m_oIcon);
            var aIcons = oMapComponent.icons;

            //Search and update icon
            for(var i=0; i<aIcons.length; ++i){
                if(m_oIcon.status == aIcons[i].status){
                    $.extend(true,aIcons[i],m_oIcon);
                    //aIcons[i] = m_oIcon;
                    break;
                }
            }



            //Set model and view
            $.publish("/model/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/update/parameter",[oMapComponent,"icons",aIcons]);

            //Subscribe for View
            $.publish("/view/uicomponent/map/mapcomponent/"+ oMapComponent.id +"/refresh/parameter",[oMapComponent,"icons"]);
        }
        if(oData instanceof User){
            var oUser = oData;
            var oIcon = oData.logoutIcon;

            $.extend(true,oIcon,m_oIcon);

            //Set model and view
            $.publish("/model/user/"+ oUser.id +"/update/parameter",[oUser,"logoutIcon",oIcon]);
            $.publish("/view/user/"+ oUser.id +"/refresh/parameter",[oUser,"logoutIcon"]);
        }
        
        //Call external window hide method
        m_oWindow.hide();
    };
}