/** iconEditor class (extends Window class)
 *
 * @class iconEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function weekEditor(oWindow){
	
	var self = this;

    var selectionState=0;
	
	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - iconEditor class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            height: "auto",
            width: "auto",
            autoOpen: false,
            modal: true,
            resizable: false,
            close: m_oWindow.hide,
            title: _D("Week Editor"),
            create: function(e,ui){
                $(this).find(".actions button").button();
            }
        });
        
        //On enable/disable color
        m_$element.on("change",".enableColors",self._colorEnabling);
        


        //On Submit
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".actions [type='reset']",function(e){
            m_oWindow.hide();
        });

        var drawing = $(".weekTime").css({
            overflow: 'hidden',
            border: '0px solid #000000',
            width: unitSize * 24 +300
        });




        $('<canvas class="WeekCanvas" width="'+unitSize*24+300+'" height="'+unitSize*8+'" style="cursor: auto;"  >').appendTo(drawing);


        $( "#weekEditorradio" ).buttonset();

        backGround.src = "../html/assets/img/weekTimeBackground.png";
        backGround.addEventListener('load', eventSheetLoaded , false);
        $(".WeekCanvas").mousemove(function(event){

            if (event.which==1)
            {
                //console.log($("#weekEditorradio1")[0].checked);
                var zzz=(event.offsetX-123);
                if (zzz<0) return;
                if (zzz>24*24) return;

                zzz=(event.offsetY-20);
                if (zzz<0) return;
                if (zzz>24*7) return;

                refreshBackGround();

                //console.log(downX);
                //console.log(downY);

                var x =parseInt((event.offsetX-123)/24);
                var y =parseInt((event.offsetY-20)/24);

                if (downX==-100) downX=x;
                if (downY==-100) downY=y;



                var newval="";
                if (selectionState==0)  newval="#575757";
                if (selectionState==1)  newval="#f68502";


                /*
                if ($("#weekEditorradio1")[0].checked) newval="#575757";
                if ($("#weekEditorradio2")[0].checked) newval="#f68502";
*/


                for (var zx=Math.min(downX,x);zx<=Math.max(downX,x);zx++)
                {
                    if (zx>=0 && zx<=23)
                    {
                        for (var zy=Math.min(downY,y);zy<=Math.max(downY,y);zy++)
                        {
                            if (zy>=0 && zy<=6)
                            {
                                $(".WeekCanvas").drawRect({
                                    draggable: false,
                                    fillStyle: newval,
                                    x: unitSize * zx + 131, y: unitSize * zy + 29,
                                    width: unitSize - 2, height: unitSize - 2
                                });
                            }
                        }
                    }
                }

                // $(this).css('cursor','pointer');
                // $(this).css("background-color","#FF0088");
            }

        });




        $(".WeekCanvas").mouseup(function(event){

            var xxx=(event.offsetX-123);
            if (xxx<0) xxx=0;
            if (xxx>24*24) xxx=24*24;

            var yyy=(event.offsetY-20);
            if (yyy<0) yyy=0;
            if (yyy>24*7) yyy=24*7;

            //console.log(valueArray[zx*zy]);
            var x =parseInt(xxx/24);
            var y =parseInt(yyy/24);

        /*    var newval=0;
            if ($("#weekEditorradio1")[0].checked) newval=0;
            if ($("#weekEditorradio2")[0].checked) newval=1;

            if (selectionState==0)  newval="#575757";
            if (selectionState==1)  newval="#f68502";
*/
            //console.log(newval);
            for (var zx=Math.min(downX,x);zx<=Math.max(downX,x);zx++)
            {
                if (zx>=0 && zx<=23) {
                    for (var zy = Math.min(downY, y); zy <= Math.max(downY, y); zy++) {
                        if (zy >= 0 && zy <= 6) {
                            valueArray[zx + (zy * 24)] = selectionState;
                        }
                    }
                }
            }
            downX=-100;
            downY=-100;
        });

        $(".WeekCanvas").mousedown(function(event){
            //console.log(valueArray[zx*zy]);
            var zzz=(event.offsetX-123);
            if (zzz<0) return;
            if (zzz>24*24) return;

            zzz=(event.offsetY-20);
            if (zzz<0) return;
            if (zzz>24*7) return;


            var x =parseInt((event.offsetX-123)/24);

            var y =parseInt((event.offsetY-20)/24);
            console.log(event.offsetX);
            console.log(x);

            if (downX==-100) downX=x;
            if (downY==-100) downY=y;
            var newval="";

            if (valueArray[x + (y * 24)]==0 )
            {
                selectionState=1;
                newval="#f68502"
            }
            else
            {
                selectionState=0;
                newval="#575757"
            }
         /*

            if ($("#weekEditorradio1")[0].checked) newval="#575757";
            if ($("#weekEditorradio2")[0].checked) newval="#f68502";
*/


            for (var zx=Math.min(downX,x);zx<=Math.max(downX,x);zx++)
            {
                console.log(zx);
                if (zx>=0  && zx<=23)
                {
                    for (var zy=Math.min(downY,y);zy<=Math.max(downY,y);zy++) {
                        if (zy>=0 && zy<=6)
                        {
                            $(".WeekCanvas").drawRect({
                                draggable: false,
                                fillStyle: newval,
                                x: unitSize * zx + 131, y: unitSize * zy + 29,
                                width: unitSize - 2, height: unitSize - 2
                            });
                        }
                    }
                }
            }

        });
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element = oWindow;
    
    /** Edited icon
     * @type {object}
     */
    var m_oIcon;

    var downX=-100;
    var downY=-100;

    var valueArray=new Array(7*24);


    var unitSize = 24; // width (and height) of one square
    var unitsWide = 24; // number of squares along x-axis
    var unitsTall = 7; // number of squares along y-axis

    var backGround = new Image();



    function refreshBackGround()
    {





        // console.log(x + ", " + y);
        for (var zx=0;zx<unitsWide;zx++)
        {
            for (var zy=0;zy<unitsTall;zy++)
            {
                var t=valueArray[zx+(zy*24)];
                var vv="";
                if (t==0) vv="#575757";
                if (t==1) vv="#f68502";

                $(".WeekCanvas").drawRect({
                    draggable: false,
                    fillStyle: vv,
                    x: unitsWide*zx+131, y: unitsWide*zy+29,
                    width:unitSize-2, height:unitSize-2
                });
            }
        }

    }
	
	/** Show icon editor window
	 */
    var parameterID="";
	this.show = function(oParam){
        parameterID=oParam;
	    var oNode = m_oWindow.getActiveNode();
	    var oData = oNode.getData();
        console.log(oNode);


        var timing=oData.getParamVal("gui/weekData");
        for (var i=0;i<24*7;i++)
        {
            if (timing.substring(i,i+1)=="1")
                valueArray[i]=1;
            else
                valueArray[i]=0;

        }

        refreshBackGround();

        m_$element.dialog("open");

	};

    function eventSheetLoaded() {


        var context = $('.WeekCanvas')[0].getContext("2d");
        context.drawImage(backGround, 0,0);

        var weekDays=["Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"];



        for (var i = 0; i < 24 ; i++) {
            $('.WeekCanvas').drawText({
                fillStyle: '#ffffff',
                strokeStyle: '#ffffff',
                strokeWidth: 0,
                x: i*unitsWide+130, y: 10,
                fontSize: 12,
                fontFamily: 'Verdana, sans-serif',
                text: i
            });
        }

        for (var days = 0; days < 7 ; days++)
        {

            $('.WeekCanvas').drawText({
                fillStyle: '#ffffff',
                strokeStyle: '#ffffff',
                strokeWidth: 0,
                x: 10, y: unitsWide*days+10+10+10,
                width: 100,
                fontSize: 12,
                fontFamily: 'Verdana, sans-serif',
                align: 'left',
                respectAlign: true,
                text: weekDays[days]
            });

        }

        $(".WeekCanvas").drawRect({
            draggable: false,
            fillStyle: "#575757",
            x: unitSize * 24 + 210, y:  60,
            width: unitSize - 2, height: unitSize - 2
        });

        $(".WeekCanvas").drawRect({
            draggable: false,
            fillStyle: "#f68502",
            x: unitSize * 24 + 210, y:  30,
            width: unitSize - 2, height: unitSize - 2
        });


        $('.WeekCanvas').drawText({
            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: unitSize * 24 + 230, y: 30,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "On"
        });


        $('.WeekCanvas').drawText({
            fillStyle: '#ffffff',
            strokeStyle: '#ffffff',
            strokeWidth: 0,
            x: unitSize * 24 + 230, y: 60,
            width: 100,
            fontSize: 12,
            fontFamily: 'Verdana, sans-serif',
            align: 'left',
            respectAlign: true,
            text: "Off"
        });
        refreshBackGround();


    }


    /** Hide icon editor window and closing operation
	 */
	this.hide = function(e,ui){
	    m_oIcon = undefined;
	    
	    //Show hidden elements
        m_$element.find(".actions [type='button']").show();
	    
	    //Close
	    m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    

    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        var oNode = m_oWindow.getActiveNode();
        var oData = oNode.getData();

        var $this = $(parameterID);

        var oNode = eveManager.getSelectComponent();
        var oComponent = oNode.getData();
        var strParam = $this.attr("eve-manager-id");


         if(oData instanceof Component){
            var oComponent = oData;
            var ret="";
            for (var i=0;i<24*7;i++)
            {
                if (valueArray[i]==0)
                {
                    ret=ret+"0"
                }
                else
                {
                    ret=ret+"1"
                }
            }
            //Set model and view
            $.publish("/model/components/"+ oComponent.id +"/update/parameter",[oComponent,"gui/weekData",ret]);
            application.selectComponent(oNode);
         }

        //Call external window hide method
        m_oWindow.hide();
    };
}