﻿/** Javascript KNX OPC server file parser (OPC file contents is inside window["knx/opc"])
 * 
 */
try{
    console.log("%cStart KNX OPC server file parsing","color:DarkSlateBlue");
    
    var aLines =  window["knx/opc"].split("\n");
    var knxProjectTitle = aLines.shift();

    //alert(knxProjectTitle);
    
    /*var oKnxJson = {
        data: new Array()
    };*/
   var oKnxJson = new Array();
    
    //Parse lines
    while(aLines.length > 0){
        var strLine = aLines.shift();
        if(strLine == ""){
            continue;
        }
        
        var aParameters = strLine.split("\t");
        
        //Get group address parameters
        // [0] -> Group description ([MAIN GROUP NAME].[INTERMEDIATE GROUP NAME].[GROUP ADDRESS])
        // [1] -> Group address name
        // [2] -> Group address type
        // [3] -> Group address level
        
        var aDescription = aParameters[0].split(".");
        var aAddress = aDescription[2].split("/");
        
        //Main group
        var mainGroup = {
            data: "<span>"+ aAddress[0] +"</span>&nbsp;<span class='name'>"+ aDescription[0] +"</span>",
            state: "open",
            attr: { "rel": "knx-main-group" },
            children: new Array()
        };
        
        //Intermediate group
        var intermediateGroup = {
            data: "<span>"+ aAddress[1] +"</span>&nbsp;<span class='name'>"+ aDescription[1] +"</span>",
            //data: aDescription[1],
            //state: "open",
            attr: { "rel": "knx-intermediate-group" },
            children: new Array()
        };
        
        //Group
        var lowerGroup = {
            data: "<span>"+ aAddress[2] +"</span>&nbsp;<span class='name'>"+ aParameters[1] +"</span>",
            //data: aParameters[1],
            attr: {
                "rel": "knx-group",
                "knx-group-address": aDescription[2],
                "title": aDescription[2]
            }
        };
        
        //Find main group
        var bFind = false;
        var mainIndex = 0;
        for(var i=0; i<oKnxJson.length; ++i){
            if(oKnxJson[i].data == mainGroup.data){
                bFind = true;
                mainIndex = i;
                break;
            }
        }
        
        //Push new Main Group element
        if(!bFind){
            mainIndex = (oKnxJson.push(mainGroup) - 1);
        }
        
        //Find intermediate group
        bFind = false;
        var interIndex = 0;
        for(var i=0; i<oKnxJson[mainIndex].children.length; ++i){
            if(oKnxJson[mainIndex].children[i].data == intermediateGroup.data){
                bFind = true;
                interIndex = i;
                break;
            }
        }
        
        //Push new intermediate Group element
        if(!bFind){
            interIndex = (oKnxJson[mainIndex].children.push(intermediateGroup) - 1);
        }
        
        //Push new lower Group element
        oKnxJson[mainIndex].children[interIndex].children.push(lowerGroup);
        
    }//end while
    
    //Write KNX parsing in a file
    //console.log(QT.writeFile("./project/assets/imports/knx/project.json",JSON.stringify(oKnxJson)));
    if(!QT.writeFile("../project/assets/imports/knx/project.json",JSON.stringify(oKnxJson))){
        alert("KNX OPC file import failed!");
        throw "KNX OPC file import failed!";
    }
    //console.log(JSON.stringify(oKnxJson));
    
    //Empty OPC variable
    //window["knx/opc"] = undefined;
    delete window["knx/opc"];
    
    //Open dialog
    $("#ets-project").dialog("open");
    
    console.log("%cStop KNX OPC server file parsing","color:DarkSlateBlue");
}
catch(err){
    console.error(err);
    alert("KNX OPC server file parsing error");
}