﻿try{
	console.log("%cStart script","color:green;");

    window["plugin/temp"] = new Object();
    window["plugin/temp"]["$dialog"] = $("<div id='plugin/temp/dialog'></div>");

    //HTML manipulation
    $("body").append(window["plugin/temp"]["$dialog"]);
    window["plugin/temp"]["$list"] = $("<ul></ul>");
    window["plugin/temp"]["$refresh"] = $("<button type='button'>Refresh</button>");
    window["plugin/temp"]["$dialog"].append(window["plugin/temp"]["$list"]);
    window["plugin/temp"]["$dialog"].append(window["plugin/temp"]["$refresh"]);

    window["plugin/temp"]["$dialog"].dialog({
        width: "auto",
        modal: true,
        title: "Plugin",
        close: function(){

            $(this).dialog("destroy").remove();
            //window["plugin/temp"]["$dialog"].remove();

            delete window["plugin/temp"];
            console.log("END");
        }
    });

    window["plugin/temp"]["process"] = {
        "busy": false,
        "pollingTime": 2000
    }

    window["plugin/temp"]["$refresh"].click(function(e){

        //console.log($.getJSON("http://10.0.0.211:7070/getLogicComponents"))
        $.getJSON("http://10.0.0.211:7070/getLogicComponents",function(json){
            for (i=0;i<json.list.length;i++){
                p=json.list[i];
                console.log(p.name);
                if(p.name=="ZWave Plugin")
                {
                    break;
                }
            }

            if (p==null || p==undefined) return;

            var clist=p.components;

            // se non ci sono dispositivi presenti termina qui
            if (clist.length==0) return;

            // controlla e aggiunge eventualmente un gateway zwave
            var g=application.getGatewaysByProtocol("zwave")[0];
            if (g==undefined)
                g=application.addGateway({protocol:"zwave"});

            window["plugin/temp"]["$list"].empty();

            // scorre i dispositivi presenti
            for (i=0;i<clist.length;i++)
            {
                var comp=clist[i];
                //console.log(comp);
                if (comp==null) continue;

                var $li = $("<li style='padding: 6px;'></li>");
                var $name = $("<span style='width: 120px; display: inline-block; font-weight: bold'>"+ comp.name +"</span>");
                var $index = $("<span style='width: 80px; display: inline-block; margin-left: 20px;'>index: "+ comp.index +"</span>");
                var $instance = $("<span style='width: 80px; display: inline-block; margin-left: 20px;'>instance: "+ comp.instance +"</span>");
                var $addComponent = $("<span style='float: right; margin-left: 100px; cursor: pointer;' class='ui-icon ui-icon-circle-plus'></span>");

                if(comp.name=="Switch Binary")
                {
                    var oPar = {
                        "name": comp.name,
                        "type": "switch",
                        "gateway": g,
                        "componentUID": comp.componentUID,
                        "subType": comp.subType,
                        "zwave/instance": comp.instance,
                        "zwave/index": comp.index
                    };
                    //console.log(g);

                    /*if(application.checkComponentExist(oPar) == false){
                        application.addComponent(oPar);
                    }*/
                }
                else if(comp.name=="Meter")
                {
                    var oPar = {
                        "name": comp.name,
                        "type": "info",
                        "gateway": g,
                        "componentUID": comp.componentUID,
                        "subType": comp.subType,
                        "zwave/instance": comp.instance,
                        "zwave/index": comp.index
                    };
                    //console.log(g);

                    /*if(application.checkComponentExist(oPar) == false){
                        application.addComponent(oPar);
                    }*/
                }

                $addComponent.data({ "pluginData": oPar });
                $addComponent.click(function(e){
                    if(application.checkComponentExist($(this).data("pluginData")) == false){
                        application.addComponent($(this).data("pluginData"));
                    }

                });

                $li.append($name).append($index).append($instance).append($addComponent);
                window["plugin/temp"]["$list"].append($li);
            }



            //window["plugin/temp"]["$dialog"].html("Trovati: "+ clist.length +" componenti");
        });

    });

    window["plugin/temp"]["$refresh"].trigger("click");

	console.log("%cStop script","color:green;");
}
catch(err){
    console.error("Script file error: "+ err);
}